Bug 92271 - Wrong character background color (imported from Visio file)
Summary: Wrong character background color (imported from Visio file)
Status: RESOLVED FIXED
Alias: None
Product: libvisio
Classification: Unclassified
Component: General (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other All
: medium normal
Assignee: Andras Timar
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-06-23 08:27 UTC by Andras Timar
Modified: 2015-12-14 10:19 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Andras Timar 2015-06-23 08:27:31 UTC
Open attachment 116752 [details] (a Visio .vsdx file) in LibreOffice 4.4. Observe that in the text box white characters are written with white background (see attachment 116753 [details]). However, in LibreOffice 4.3 the text is white on black background. I wonder, if it is a libvisio bug, or a regression.

Bibisect shows that behaviour changed in this commit range:
b20e6acea2cb2013f450bb4b97b51142dbb4f161..88bd199e761a165b8add0cebac9f149dc4250829

Suspicious commits in this range:
2727a6d Changed BColor to Color in TextFooPrimitive2D classes
c2d5c39 Removed assertion in EditCharAttribBackgroundColor
4bfa845 Associated CharBackColor to EE_CHAR_BKGCOLOR
9ab4387 Added Text Fill Color in TextDecoratedPrimitive2D
6c1fc9e Added Text Fill Color in TextSimplePortionPrimitive2D
Comment 1 Andras Timar 2015-06-23 08:29:27 UTC
@Matteo, your commits are involved in this regression, can you please check? Thanks.
Comment 2 tommy27 2015-06-23 11:59:03 UTC
I confirm issue in LibO 4.4.3.2 and recent 5.1.0.0 alpha
that file has different look in respect to 4.3.5.2 as Andras described.

status NEW
Comment 3 Katarina Behrens (CIB) 2015-06-25 10:04:49 UTC
@Andras: Is it any better w/ master? 

Workaround: you can use the new UI (bug 88276), sidebar or toolbar, to set the background of the text to transparent. Dunno yet if the background is really white and 4.3 just happens to be bug-compatible or if it is transparent and LibO screws it up by importing it as white
Comment 4 Andras Timar 2015-06-25 10:08:37 UTC
(In reply to Katarina Behrens (CIB) from comment #3)
> @Andras: Is it any better w/ master? 

attachment 116754 [details] is the reference rendering (in Visio 2013). Master is not better.
Comment 5 Andras Timar 2015-06-25 21:53:21 UTC
LibreOffice is innocent. Libvisio dumps this:

          openSpan(fo:background-color: #ffffff, fo:color: #feffff, fo:font-size: 8.0000pt, style:font-name: Calibri, svg:fill-opacity: 100.0000%, svg:stroke-opacity: 100.0000%)
            insertText (Standard setup 15.000+ concurrent users on one server)
          closeSpan

Note the fo:background-color: #ffffff. It should be transparent. Or the svg:fill-opacity should be 0.
Comment 6 Andras Timar 2015-06-29 13:21:28 UTC
More precisely:
1. When char background is not set, we should not export white.
2. When char background is set, we should export that color, not black (VSDX)

Note: unfortunately transparency is not supported in Draw.
Comment 8 Fridrich Strba 2015-12-14 10:19:56 UTC
Seeing this good, resolving as fixed